/*********************************************************************************************
 * (c) COPYRIGHT 2021 by NetModule AG, Switzerland
 * -------------------------------------------------------------------------------------------
 *
 * InfoCollector-private HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : InfoCollector-private.h
 * CREATION DATE : Oct 26, 2021
 * TARGET        : embedded Linux
 *
 *********************************************************************************************/
#ifndef SRC_INFOCOLLECTOR_PRIVATE_H_
#define SRC_INFOCOLLECTOR_PRIVATE_H_

#include <nmapp/file/IFileOperation.h>
#include "info-containers.h"
#include "InfoCollector.h"


#ifdef __cplusplus
extern "C" {
#endif


/*********************************************************************************************
 *        PRIVATE DECLARATIONS
 *********************************************************************************************/

#define MMC_CHIPNAME_FILENAME               "name"
#define MMC_HWREVISION_FILENAME             "hwrev"
#define MMC_SERIALNBR_FILENAME              "serial"
#define MMC_REVISION_FILENAME               "rev"
#define MMC_FWVERSION_FILENAME              "fwrev"
#define MMC_RELIABLEWRITE_PARAM_FILENAME    "rel_param"
#define MMC_RELIABLEWRITE_SETUP_FILENAME    "rel_write_set"
#define MMC_LIFETIME_FILENAME               "life_time"
#define MMC_PREEOLINFO_FILENAME             "pre_eol_info"

#define MMC_INFO_BUFFER_SIZE                32

#define INVALID_LIFETIME_VALUE             (-1)

typedef struct
{
    char chipName[MMC_INFO_BUFFER_SIZE];
    char hwRevision[MMC_INFO_BUFFER_SIZE];
    char revision[MMC_INFO_BUFFER_SIZE];
    char fwVersion[MMC_INFO_BUFFER_SIZE];
    char serialNbr[MMC_INFO_BUFFER_SIZE];
    char tmp[MMC_INFO_BUFFER_SIZE];
} InfoBuffers_t;

typedef struct __InfoCollectorPrivate
{
    ILogRef             logRef;
    StorageDetectorRef  mmcDetectorRef;
    IFileOperationRef   fileOpItf;
    InfoBuffers_t       buffers;
    StaticInfo_t        staticInfo;
    DynamicInfo_t       dynamicInfo;
    float64_t*          diskUsageArrMB;
} InfoCollectorPrivate_t;



/*********************************************************************************************
 *        PRIVATE FUNCTIONS
 *********************************************************************************************/


#ifdef __cplusplus
}
#endif

#endif /* SRC_INFOCOLLECTOR_PRIVATE_H_ */
